/**
 * Freqtrade API
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: 2021.12-dev21
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 *
 */


import ApiClient from "../ApiClient";
import BacktestRequest from '../model/BacktestRequest';
import BacktestResponse from '../model/BacktestResponse';
import HTTPValidationError from '../model/HTTPValidationError';

/**
* Backtest service.
* @module ftclient/BacktestApi
* @version 2021.12-dev21
*/
export default class BacktestApi {

    /**
    * Constructs a new BacktestApi. 
    * @alias module:ftclient/BacktestApi
    * @class
    * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
    * default to {@link module:ApiClient#instance} if unspecified.
    */
    constructor(apiClient) {
        this.apiClient = apiClient || ApiClient.instance;
    }



    /**
     * Api Backtest Abort
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/BacktestResponse} and HTTP response
     */
    apiBacktestAbortApiV1BacktestAbortGetWithHttpInfo() {
      let postBody = null;

      let pathParams = {
      };
      let queryParams = {
      };
      let headerParams = {
      };
      let formParams = {
      };

      let authNames = ['HTTPBasic', 'OAuth2PasswordBearer'];
      let contentTypes = [];
      let accepts = ['application/json'];
      let returnType = BacktestResponse;
      return this.apiClient.callApi(
        '/api/v1/backtest/abort', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, null
      );
    }

    /**
     * Api Backtest Abort
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/BacktestResponse}
     */
    apiBacktestAbortApiV1BacktestAbortGet() {
      return this.apiBacktestAbortApiV1BacktestAbortGetWithHttpInfo()
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Api Delete Backtest
     * Reset backtesting
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/BacktestResponse} and HTTP response
     */
    apiDeleteBacktestApiV1BacktestDeleteWithHttpInfo() {
      let postBody = null;

      let pathParams = {
      };
      let queryParams = {
      };
      let headerParams = {
      };
      let formParams = {
      };

      let authNames = ['HTTPBasic', 'OAuth2PasswordBearer'];
      let contentTypes = [];
      let accepts = ['application/json'];
      let returnType = BacktestResponse;
      return this.apiClient.callApi(
        '/api/v1/backtest', 'DELETE',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, null
      );
    }

    /**
     * Api Delete Backtest
     * Reset backtesting
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/BacktestResponse}
     */
    apiDeleteBacktestApiV1BacktestDelete() {
      return this.apiDeleteBacktestApiV1BacktestDeleteWithHttpInfo()
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Api Get Backtest
     * Get backtesting result. Returns Result after backtesting has been ran.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/BacktestResponse} and HTTP response
     */
    apiGetBacktestApiV1BacktestGetWithHttpInfo() {
      let postBody = null;

      let pathParams = {
      };
      let queryParams = {
      };
      let headerParams = {
      };
      let formParams = {
      };

      let authNames = ['HTTPBasic', 'OAuth2PasswordBearer'];
      let contentTypes = [];
      let accepts = ['application/json'];
      let returnType = BacktestResponse;
      return this.apiClient.callApi(
        '/api/v1/backtest', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, null
      );
    }

    /**
     * Api Get Backtest
     * Get backtesting result. Returns Result after backtesting has been ran.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/BacktestResponse}
     */
    apiGetBacktestApiV1BacktestGet() {
      return this.apiGetBacktestApiV1BacktestGetWithHttpInfo()
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Api Start Backtest
     * Start backtesting if not done so already
     * @param {module:model/BacktestRequest} backtestRequest 
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/BacktestResponse} and HTTP response
     */
    apiStartBacktestApiV1BacktestPostWithHttpInfo(backtestRequest) {
      let postBody = backtestRequest;
      // verify the required parameter 'backtestRequest' is set
      if (backtestRequest === undefined || backtestRequest === null) {
        throw new Error("Missing the required parameter 'backtestRequest' when calling apiStartBacktestApiV1BacktestPost");
      }

      let pathParams = {
      };
      let queryParams = {
      };
      let headerParams = {
      };
      let formParams = {
      };

      let authNames = ['HTTPBasic', 'OAuth2PasswordBearer'];
      let contentTypes = ['application/json'];
      let accepts = ['application/json'];
      let returnType = BacktestResponse;
      return this.apiClient.callApi(
        '/api/v1/backtest', 'POST',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, null
      );
    }

    /**
     * Api Start Backtest
     * Start backtesting if not done so already
     * @param {module:model/BacktestRequest} backtestRequest 
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/BacktestResponse}
     */
    apiStartBacktestApiV1BacktestPost(backtestRequest) {
      return this.apiStartBacktestApiV1BacktestPostWithHttpInfo(backtestRequest)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


}
